// Programmfunktion ----------------------------------------------------------------------------------------------------------
/*
Das Programm macht Testausgaben auf der zweiten Seriellen Schnittstelle am Evalboard (CAN/RS232 Stecker).
Anschlieend werden alle Zeichen die ankommen unverndert wieder zurckgesendet (Echo-Funktion).
*/
// Resourcen-----------------------------------------------------------------------------------------------------------------


// Includes -----------------------------------------------------------------------------------------------------------------
#include <reg167.h>
#include <stdio.h>   // ntig fr Kontrollausgabe mit printf
#include "rs232.h"


// Defines -----------------------------------------------------------------------------------------------------------------
#define ESC "\033"	/* das Escape-Zeichen */
#define CSI ESC"["	/* die sog. CSI-Sequenz */

// Structures -----------------------------------------------------------------------------------------------------------------


// Externals -----------------------------------------------------------------------------------------------------------------


// Globals -----------------------------------------------------------------------------------------------------------------
char winkel = 0;

// Functions -----------------------------------------------------------------------------------------------------------------


void main ()
{
unsigned char c;
long int i;

  send_receive_init ();

  IEN=1;



  
	//Kanonengrundgerst
    printf ("\033[50;10H""\033[6n");					
	printf ("  OOOOOO");
	printf ("\033[51;10H""\033[6n");
	printf (" OOOOOOOO");
	printf ("\033[52;10H""\033[6n");
	printf ("OOOOOOOOOO XX");
	printf ("\033[53;10H""\033[6n");
	printf (" OOOOOOOO");
	printf ("\033[54;10H""\033[6n");
	printf ("  OOOOOO");
	printf ("\033[55;10H""\033[6n");
	printf ("XX      XX");


//Gerades Kanonenrohr! Lscht vorher mgliche schrgen Kanonenrohre weg und zeichnet dann gerade!
  if (winkel <= 15 && winkel >= -15){	                            
      printf("\033[52;23H" "\033[6n");
	  printf("\033[D""\033[6n");	   
      printf("\033[A""\033[6n");	   
	  printf("  ");					   
	  printf("\033[D""\033[6n");	  
      printf("\033[A""\033[6n");	  
	  printf("  ");
	  printf("\033[D""\033[6n");
      printf("\033[A""\033[6n");	   	
	  printf("  ");
	  printf("\033[D""\033[6n");
      printf("\033[A""\033[6n");	   	
	  printf("  ");
	  printf("\033[D""\033[6n");
      printf("\033[A""\033[6n");	   	
	  printf("  ");
	  printf("\033[D""\033[6n");
      printf("\033[A""\033[6n");
	  printf("  ");
	  printf("\033[52;23H" "\033[6n");
	  printf("\033[D""\033[6n");
      printf("\033[B""\033[6n");
	  printf("  ");
	  printf("\033[D""\033[6n");
      printf("\033[B""\033[6n");
	  printf("  ");
	  printf("\033[D""\033[6n");
      printf("\033[B""\033[6n");	   	
	  printf("  ");
	  printf("\033[D""\033[6n");
      printf("\033[B""\033[6n");	   	
	  printf("  ");
	  printf("\033[D""\033[6n");
      printf("\033[B""\033[6n");	   	
	  printf("  ");
	  printf("\033[D""\033[6n");
      printf("\033[B""\033[6n");
	  printf("  ");
	  printf("XXXXXXXXX");


  }

  if (winkel > 15){ 		           //Kanonenrohr hinauf
	  printf("\033[52;23H" "\033[6n"); // Springe an Position wo nur 2 "X" stehen
      printf("            ");		   // Lsche restliche X mit Leerzeichen raus
      printf("\033[52;23H" "\033[6n"); //Springe zurck
	  printf("\033[D""\033[6n");	   //eins nach links
      printf("\033[A""\033[6n");	   //eins rauf
	  printf("XX");					   //schreibe 2 X
	  printf("\033[D""\033[6n");	   //eins zurck
      printf("\033[A""\033[6n");	   //eins rauf
	  printf("XX");
	  printf("\033[D""\033[6n");
      printf("\033[A""\033[6n");	   	
	  printf("XX");
	  printf("\033[D""\033[6n");
      printf("\033[A""\033[6n");	   	
	  printf("XX");
	  printf("\033[D""\033[6n");
      printf("\033[A""\033[6n");	   	
	  printf("XX");
	  printf("\033[D""\033[6n");
      printf("\033[A""\033[6n");
	  printf("XX");	   	
	   	
  }
  if (winkel < -15){		 	                	//Kanonenrohr hinunter
      printf("\033[52;23H" "\033[6n");
      printf("            ");
      printf("\033[52;23H" "\033[6n");
	  printf("\033[D""\033[6n");
      printf("\033[B""\033[6n");
	  printf("XX");
	  printf("\033[D""\033[6n");
      printf("\033[B""\033[6n");
	  printf("XX");
	  printf("\033[D""\033[6n");
      printf("\033[B""\033[6n");	   	
	  printf("XX");
	  printf("\033[D""\033[6n");
      printf("\033[B""\033[6n");	   	
	  printf("XX");
	  printf("\033[D""\033[6n");
      printf("\033[B""\033[6n");	   	
	  printf("XX");
	  printf("\033[D""\033[6n");
      printf("\033[B""\033[6n");
	  printf("XX");  
  } 





  for (i=0;i<100000;i++);   // abwarten bis Zeichen auch sicher drauen ist
                            // buffer_put_wait wartet Ausgabe nicht ab
                            // ersten Breakpoint erst nach dieser Schleife setzen


  while(1) {
    c=buffer_get_wait(&receive_buffer);  // nicht wartendes Lesen aus dem Buffer, wenn nichts drin kommt \0
    printf("%c", c);
    //buffer_put_wait(c, &send_buffer);
  }
}

