#define MAXSIZE 64

struct buffer {
	unsigned char data [MAXSIZE];
	int p_in;
	int p_out;
};


extern struct buffer receive_buffer;
extern struct buffer send_buffer;


void send_receive_init (void);
void receive_isr (void);
void send_isr (void);
void buffer_put_nowait (unsigned char zeichen, struct buffer *buf);
char buffer_get_nowait (struct buffer *buffer);

void buffer_put_wait (unsigned char zeichen, struct buffer *buf);
char buffer_get_wait (struct buffer *buffer);
